
LoadAddOn("FuBarPlugin-3.0")

local _G				= getfenv(0)

local pairs			    = _G.pairs
local select			= _G.select
local type              = _G.type

local table_insert		= _G.table.insert
local table_remove		= _G.table.remove
local table_sort		= _G.table.sort

local GetGuildRosterInfo	= _G.GetGuildRosterInfo
local GetNumGuildMembers	= _G.GetNumGuildMembers
local GetItemInfo	        = _G.GetItemInfo


_G.GigaItemAuction = LibStub("AceAddon-3.0"):NewAddon("GigaItemAuction", "AceConsole-3.0", "AceTimer-3.0", "AceEvent-3.0")

local GigaItemAuction = _G.GigaItemAuction

local L = LibStub("AceLocale-3.0"):GetLocale("GigaItemAuction", false)
local LDB = LibStub("LibDataBroker-1.1", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
local tablet = AceLibrary("Tablet-2.0")

local db

local selfBid = false
local adminBreak = false
local falseVersionMSG = false
local auctionPAUSE = false
local auctionSTART = false
local auctionSONDERBID = false
local auctionMITBIETEN = true
local waitForVersionIncomig = false

local groupList = {}
local guildList = {}
local versionList = {}



local PLAYERNAME = UnitName("player")
local _, PLAYERCLASS = UnitClass("player");

---------

local defaults = {
	profile = {
		config = {
			startAddon = true,
			showAuctionWindow = false,
			showAdminWindow = false,
			debugmodus = false,
			debugadmin = false,
			bidTime = 30,
			bidArt = "M",
			bidU80 = false,
			bidUP = 80,
			announceAuction = false,
			playsound = {
				auctionend = true,
				auctionstart = true,
				newgebot = true,
				backgebot = true,
				pause = true,
				pausestart = true,
				errormsg = true,
				longauction = true,
			},
			bidStep = {
				step1 = 5,
				step2 = 10,
				step3 = 25,
				step4 = 50,
			},
		},
		position = {
			x = 0,
			y = 0,
			relpoint = "CENTER",
			point = "CENTER",
		},
		nowAuction = {
			itemID = 0,
			itemLink = "",
			auctionAuthor = "",
			channel = "",
			last = {
				BidName = "",
				BidPoint = 0,
				BidTime = 0,
				BidArt = "X",
				BidU80 = false
			},
			cache = {
	--~ 		{BidName = "string", BidPoint = "number", BidTime = "number", BidArt = "string", BidU80 = "boolean"}
			},
		},
		auctionCache = {
	--~ 	{BidName = "string", BidItem = "string", BidPoint = "number", BidTime = "number", BidArt = "string", BidU80 = "boolean", BidMethod = "string"}
		},
		filter = {
			class = PLAYERCLASS,
			itemType = {
				showAll = true,
			},
			itemSubType = {},
			itemEquipLoc = {},
		},
		FuBar = {
			HideMinimapButton = false,
			AttachMinimap = false,
		},
		MinimapIcon = {
			hide = false,
			minimapPos = 220,
			radius = 80,
		},
	}
}
---------

GigaItemAuction.mainmenuopts = options
GigaItemAuction.revision = tonumber(string.sub("$Revision: 20246 $", 12, -3))
GigaItemAuction.revisionNEW = GigaItemAuction.revision
GigaItemAuction.versioncheckraid = 0
GigaItemAuction.versioncheckguild = 0

--~ AddonMessages
GigaItemAuction.amsg = {
    prefix = "GIAAM",
    key = {
		bidpoint 			= "BP",
		endauction 			= "EA",
		breakauction 		= "BA",
		newbidtime 			= "NB",
		auctionlong 		= "AL",
		
		sendauctiondata 	= "SAD",
		getauctiondata 		= "GAD",
		
		sendtruebid 		= "STB",
		sendfalsebid 		= "SFB",
		sendpassbid 		= "SPB",
		
		sendresetauction 	= "SRA",
		sendstartauction 	= "SSA",
		sendpauseauction 	= "SPA",
		
		sendbidtime 		= "SBT",
		getbidtime 			= "GBT",
		
		sendtimecheck 		= "STC",
		gettimecheck 		= "GTC",
		
        sendversioncheck 	= "SVC",
        getversioncheck 	= "GVC",
        revision 			= "V",
    }
}
----------
GigaItemAuction.itemEquipLoc = {
		["INVTYPE_2HWEAPON"] 		= L["EquipLoc Two Hand"], -- Two-Hand
		["INVTYPE_BODY"] 			= L["EquipLoc Shirt"], -- Shirt
		["INVTYPE_CHEST"] 			= L["EquipLoc Chest"], -- Chest
		["INVTYPE_CLOAK"] 			= L["EquipLoc Back"], -- Back
		["INVTYPE_FEET"] 			= L["EquipLoc Feet"], -- Feet
		["INVTYPE_FINGER"] 			= L["EquipLoc Finger"], -- Finger
		["INVTYPE_FINGER_OTHER"] 	= L["EquipLoc Finger"], -- Finger_other
		["INVTYPE_HAND"] 			= L["EquipLoc Hands"], -- Hands
		["INVTYPE_HEAD"] 			= L["EquipLoc Head"], -- Head
		["INVTYPE_HOLDABLE"] 		= L["EquipLoc Off Hand"], -- Held In Off-hand
		["INVTYPE_LEGS"] 			= L["EquipLoc Legs"], -- Legs
		["INVTYPE_NECK"] 			= L["EquipLoc Neck"], -- Neck
		["INVTYPE_RANGED"] 			= L["EquipLoc Ranged"], -- Ranged
		["INVTYPE_RANGEDRIGHT"] 	= L["EquipLoc Ranged"], -- Ranged
		["INVTYPE_RELIC"] 			= L["EquipLoc Relic"], -- Relic
		["INVTYPE_ROBE"] 			= L["EquipLoc Chest"], -- Chest
		["INVTYPE_SHIELD"] 			= L["EquipLoc Shield"], -- Off Hand	Shield
		["INVTYPE_SHOULDER"] 		= L["EquipLoc Shoulder"], -- Shoulder
		["INVTYPE_TABARD"] 			= L["EquipLoc Tabard"], -- Tabard
		["INVTYPE_TRINKET"] 		= L["EquipLoc Trinket"], -- Trinket
		["INVTYPE_TRINKET_OTHER"] 	= L["EquipLoc Trinket"], -- Trinket_other
		["INVTYPE_WAIST"] 			= L["EquipLoc Waist"], -- Waist
		["INVTYPE_WEAPON"] 			= L["EquipLoc One Hand"], -- One-Hand
		["INVTYPE_WEAPON_OTHER"] 	= L["EquipLoc One Hand"], -- One-Hand_other
		["INVTYPE_WEAPONMAINHAND"] 	= L["EquipLoc Main Hand"], -- Main Hand
		["INVTYPE_WEAPONOFFHAND"] 	= L["EquipLoc Off Hand"], -- Off Hand
		["INVTYPE_WRIST"] 			= L["EquipLoc Wrist"], -- Wrist
		["INVTYPE_WAND"] 			= L["EquipLoc Wand"], -- Wand
		["INVTYPE_GUN"] 			= L["EquipLoc Gun"], -- Gun
		["INVTYPE_GUNPROJECTILE"] 	= L["EquipLoc Projectile"], -- Projectile
		["INVTYPE_BOWPROJECTILE"] 	= L["EquipLoc Projectile"], -- Projectile
		["INVTYPE_CROSSBOW"] 		= L["EquipLoc Crossbow"], -- Crossbow
		["INVTYPE_THROWN"] 			= L["EquipLoc Thrown"], -- Thrown
}
----------
GigaItemAuction.BidPriority = {
	["M"] 	= 1,
	["MU"] 	= 2,
	["S"] 	= 3,
	["SU"]	= 4,
	["F"]	= 5,
	["FU"]	= 6,
	["X"]	= 7,
}
----------
GigaItemAuction.colors = {
	neutral 	= {0.5, 0.5, 0.5, 1},
	red			= {1,   0,   0,   1},
	green		= {0,   1,   0,   1},
	blue		= {0.3, 0.3, 1,   1},
	yellow		= {1,   1,   0,   1},
	white		= {1,	1,	 1,	  1},
	black_trans	= {0, 	0, 	 0, 0.8},
	blue_trans	= {0, 	0, 0.4, 0.9},
	red_trans	= {0.4, 0, 	 0, 0.9},
}
----------
GigaItemAuction.ScheduleTimers = {
	StopAuction = false,
	SetButtonEnable = false,
	VersionCheckEnd = false,
}

---------------------------------------
-- local functione 
---------------------------------------
local function getGameTimeAsUnix()
--~ 	local h, m = GetGameTime()
--~ 	local n = date("*t")
--~ 	n.hour = h
--~ 	n.min = m
--~ 	return time(n)
	return time()
end

local function getCurrentDate(timestamp, short)
   local dt = date("*t", timestamp)
   if short then
      return string.format("%02d:%02d:%02d", dt.hour, dt.min, dt.sec)
   else
      return string.format("%02d/%02d/%d - %02d:%02d:%02d", dt.day , dt.month, dt.year, dt.hour, dt.min, dt.sec)
   end
end

local function getCurrentMiniDate(timestamp)
	local dt = date("*t", timestamp)
	return string.format("%02d:%02d:%02d - %02d/%02d", dt.hour, dt.min, dt.sec, dt.day , dt.month)
end

local function splitMessage(msg)
    return strsplit(" ",msg)
end
----------

---------------------------------------
--~ Addon Initialiaze
---------------------------------------
function GigaItemAuction:DataBaseOnInitialize(database)
	db = database
	
	--initialize database
	self:OPTIONSOnInitialize()
	self:FRAMEOnInitialize()
	self:ADMINOnInitialize()
	self:FILTEROnInitialize()
end

function GigaItemAuction:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("GigaItemAuctionDB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	
	self:DataBaseOnInitialize(self.db.profile)
	
	----------
	local s = {}
	s.kurz, s.kula = "u"..db.config.bidUP, L["u80"]:format(db.config.bidUP)
	self.BidArt = {
		kurz = {"M","S","F",s["kurz"]},
		lang = {"Main", "Second", "Fun", s["kula"]},
		kula = {
			["M"] = "Main", 
			["S"] = "Second", 
			["F"] = "Fun", 
			[s["kurz"]] = s["kula"],
		}
	}
	
	--create frames
	self:CreateAUCTIONFrame()
	self:CreateADMINFrame()
	
	--hide frames
	self:HideAUCTIONFrame()	
	self:HideADMINFrame()
	
	--config initialize and setup
	self:SetupOptions()
    
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "GIAFuBarOnInitialize")
end
function GigaItemAuction:OnProfileChanged(event, database, newProfileKey)
	self:DataBaseOnInitialize(database)
end
function GigaItemAuction:OnEnable(called)
	self:Print(L["Enable."])
	
	
    self:RegisterEvent("CHAT_MSG_WHISPER")
    self:RegisterEvent("CHAT_MSG_RAID")
    self:RegisterEvent("CHAT_MSG_RAID_LEADER","CHAT_MSG_RAID")
    self:RegisterEvent("CHAT_MSG_GUILD")
    self:RegisterEvent("CHAT_MSG_ADDON")
    self:RegisterEvent("RAID_ROSTER_UPDATE")
--~     self:RegisterEvent("GUILD_ROSTER_UPDATE", "RAID_ROSTER_UPDATE")
	
    db.config.startAddon = true
	
	self:ClearNowAuction()
	self:GIAFuBarChangeState()
	
	if UnitInRaid("player") or IsInGuild() then 
		self:SendAddonMSG(self.amsg.key.revision, self.revision, "GUILD") 
	end
end

function GigaItemAuction:OnDisable()
    self:Print(L["Disable."])
    self:GIAFuBarChangeState()
	self:HideAUCTIONFrame()
end
---










---------------------------------------
--~ EventEmpfang
---------------------------------------
function GigaItemAuction:CHAT_MSG_ADDON(event, pre, msg, typ, author)
    if pre ~= self.amsg.prefix then return end
    if typ ~= "GUILD" and typ ~= "RAID" and typ ~= "WHISPER" then return end

    local key, value = splitMessage(msg)
	local dbc = db.config
	local dbn = db.nowAuction
	local addonMSG = self.amsg.key
	local cplayer, cclass, cauthor
	
	if IsInGuild() then
		cplayer, cclass = self:GetGuildPlayer(author)
		if cplayer and cplayer ~= L["unknown"] then
			cauthor = "|cff" .. self:GetClassHexColor(cclass) .. cplayer .. "|r"
		else
			cauthor = author
		end
	else
		cauthor = author
	end
	
	
    if typ == "GUILD" or typ == "RAID" then
	
--~ Gebot kommt an
		if key == addonMSG.sendtruebid then		
			self:NewBidAuction(value, author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Bid true. ["..cauthor.."]")
			end
			
--~ Versteigerung abgebrochen
		elseif key == addonMSG.breakauction then
			adminBreak = author
			self:StopAuction()
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Auction break. ["..cauthor.."]")
			end
			
--~ Versteigerung verlaengern
		elseif key == addonMSG.auctionlong then
			self:AdminAuctionLonger(author, auctionSTART)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Current auction bidtime edit. ["..cauthor.."]")
			end
			
--~ Versteigerungszeit geaendert
		elseif key == addonMSG.newbidtime then
			dbc.bidTime = tonumber(value)
			if self:CheckPriority(PLAYERNAME) then
				self.ADMINFrame.timeSlider:SetValue(dbc.bidTime)
				self:Print("ADMIN: Bietzeit von ["..cauthor.."] auf "..value.." sec. geaendert.")
			elseif dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - New bidtime. ["..cauthor.."]")
			end
			
--~ Raid version check
        elseif key == addonMSG.sendversioncheck then
            self:SendAddonMSG(addonMSG.getversioncheck, self.revision.."#"..PLAYERCLASS.."#"..UnitName("player").."#"..(self:CheckPriority(PLAYERNAME) and 1 or 0).."#"..dbc.bidTime, "WHISPER", author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r SEND - My Version send to ["..cauthor.."].")
			end
			
--~ Version testing
        elseif key == addonMSG.revision then
			if tonumber(value) > tonumber(self.revision) and tonumber(value) > tonumber(self.revisionNEW) then
				self.AUCTIONFrame.Title:SetText("|cffff6e6e"..L["NEW"]..": |r |cff55ff55r"..value.."|r | "..L["YOUR"]..": |cffff5555r"..self.revision.."|r")
				self.revisionNEW = tonumber(value)
				if not falseVersionMSG then
					self:Print(L["hinweis4"])
					falseVersionMSG = true
				end
			else
				self.AUCTIONFrame.Title:SetText(L["GigaItemAuction"])
			end
			
			if dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - ["..cauthor.."] send version.")
			end
			
--~ Start Auction
		elseif key == addonMSG.sendstartauction then
			self:PauseStartAuction(author, true)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Auction started by ["..cauthor.."].")
			end
			
--~ Pause Auction
		elseif key == addonMSG.sendpauseauction then
			self:PauseStartAuction(author, false)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Auction paused by ["..cauthor.."].")
			end
			
--~ Reset Auction
		elseif key == addonMSG.sendresetauction then
			self:ResetAuction(author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Auction reset by ["..cauthor.."].")
			end
		elseif key == addonMSG.sendfalsebid then
			self:FalseBidAuction(value, author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Errorreport by ["..cauthor.."].")
			end
		end
		
		
		
    elseif typ == "WHISPER" then
--~ Raid version incoming
        if key == addonMSG.getversioncheck then
            self:VersionShowAll(value)
--~ Wenn Bietzeit anders ist, dann aktuallisieren
		elseif key == addonMSG.sendbidtime then
			local cbidTime, cbidUP = strsplit("#", value)
			if tonumber(cbidTime) ~= dbc.bidTime then
				self:AdminAuctionEdit(tonumber(cbidTime))
			end
			if tonumber(cbidUP) ~= dbc.bidUP then
				dbc.bidUP = tonumber(cbidUP)
			end
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Response new Bidtime from ["..cauthor.."].")
			end
--~ Author wird nach Bietzeit gefragt
        elseif key == addonMSG.getbidtime and db.nowAuction.auctionAuthor == PLAYERNAME and author ~= PLAYERNAME then
            self:SendAddonMSG(addonMSG.sendbidtime, dbc.bidTime.."#"..dbc.bidUP, "WHISPER", author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r SEND - Send interpellate for Bidtime to ["..cauthor.."].")
			end
--~ Gebot von Player kommt rein
		elseif key == addonMSG.bidpoint then
			self:IncomingNewBid(value, author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Bid from ["..cauthor.."] incomig.")
			end
--~ Pass von Player kommt rein
		elseif key == addonMSG.sendpassbid then
			self:IncomingPassLastBid(author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Bid for ["..cauthor.."] withdraw.")
			end
--~ VersteigerungsDatenVergleich incoming
		elseif key == addonMSG.sendauctiondata then
			self:IncomingAuctionDATA(value, author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - AuctionData from ["..cauthor.."] incomig.")
			end
--~ VersteigerungsDatenVergleich send
		elseif key == addonMSG.getauctiondata then
			if auctionSTART then
				local auctionDATA = dbn.itemID .."#".. dbn.auctionAuthor .."#".. dbn.channel .."#".. dbn.last.BidName .."#".. dbn.last.BidPoint .."#".. dbn.last.BidTime .."#".. dbn.last.BidArt .."#".. (dbn.last.BidU80 and 1 or 0)
				self:SendAddonMSG(addonMSG.sendauctiondata, auctionDATA, "WHISPER", author)
			end
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r SEND - AuctionData from ["..cauthor.."] submitted and to you send.")
			end
--~ Fehlgebot RÃ¼ckmeldung
		elseif key == addonMSG.sendfalsebid then
			self:FalseBidAuction(value, author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG:|r INCOMING - Errorreport from ["..cauthor.."] incoming.")
			end
		end
	end
end

function GigaItemAuction:CHAT_MSG_RAID(event, text, author)
	if not db.config.startAddon then return end
		
	if string.sub(text, -2) == "5#" then
		
		if db.config.debugmodus then
			self:Print("|cff5555ffDEBUG:|r INCOMING - New Auction. Channel: RAID")
		end
		
--~ 		Itemdata defenieren
		local itemName, itemLink = GetItemInfo(string.sub(text, 1, -2))
		
		if itemName and itemLink then
			self:StartAuction(text, author, "RAID")
		end
	end
	
end

function GigaItemAuction:CHAT_MSG_GUILD(event, text, author)
	if not db.config.startAddon then return end
	
	if string.sub(text, -2) == "5#" then
		
		if db.config.debugmodus then
			self:Print("|cff5555ffDEBUG:|r INCOMING - New Auction. Channel: GUILD")
		end
		
--~ 		Itemdata defenieren
		local itemName, itemLink = GetItemInfo(string.sub(text, 1, -2))
		
		if itemName and itemLink then
			self:StartAuction(text, author, "GUILD")
		end
	end
	
end

function GigaItemAuction:CHAT_MSG_WHISPER(event, text, author)
    if not db.config.startAddon then return end
	
	if string.sub(text, -2) == "5#" and db.config.debugadmin then
		
		self:Print("|cff5555ffDEBUG:|r INCOMING - New Auction. Channel: WHISPER")
		
--~ 		Itemdata defenieren
		local itemName, itemLink = GetItemInfo(string.sub(text, 1, -2))
		
		if itemName and itemLink then
			self:StartAuction(text, author, "WHISPER")
		end
		
	end
end

function GigaItemAuction:RAID_ROSTER_UPDATE()
	
	if UnitInRaid("player") then
		local NumRaidMember = GetNumRaidMembers()    
		if self.versioncheckraid ~= NumRaidMember then
			self:SendAddonMSG(self.amsg.key.revision, self.revision, "RAID")
			self.versioncheckraid = NumRaidMember
		end
--~ 	elseif IsInGuild() then
--~ 		self:SendAddonMSG(self.amsg.key.revision, self.revision, "GUILD")
	end
	
end



---------------------------------------
--~ Auctionen
---------------------------------------
function GigaItemAuction:StartAuction(text, author, channel)

--~ 	ÃœberprÃ¼fung, ob der Sender die Berechtigung hat eine Action zu starten
	if not self:CheckPriority(author) then 
		if PLAYERNAME == author then
			self:Print(L["secutity1"])
		end
		return 
	end
	
	if channel == "GUILD" then
		self:SendAddonMSG(self.amsg.key.revision, self.revision, "GUILD")
	end
	
	auctionSTART = true
	
	self:ClearNowAuction()
--~ 	Itemdata defenieren
	local itemName, itemLink, itemRarity, _, _, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(string.sub(text, 1, -2))
	local itemID = select(3, itemLink:find("item:(%d+):"))
	itemID = tonumber(itemID:trim())
		
	if db.config.debugadmin then
		self:Print("|cff5555ffDEBUG:|r ITEM - "..
		"itemName:"..(itemName or "nil")..", itemRarity:"..(itemRarity or "-")..", itemType:"..(itemType or "-")..", itemSubType:"..(itemSubType or "-")..", itemEquipLoc:"..(itemEquipLoc or "-"))
	end
	
	auctionMITBIETEN = self:ItemFilterCheck(itemType, itemSubType, itemEquipLoc)
	
	if author == PLAYERNAME then
		auctionMITBIETEN = true
	end
	
	local dbn = db.nowAuction
	dbn.itemID = itemID
	dbn.itemLink = itemLink
	dbn.auctionAuthor = author
	dbn.channel = channel
	dbn.last.BidName = ""
	dbn.last.BidPoint = tonumber(0)
	dbn.last.BidArt = "X"
	dbn.last.BidU80 = false

	self:SendAddonMSG(self.amsg.key.getbidtime, 1, "WHISPER", author)
	
	self:StartAdmin()

	self:StopStatusbar()
	
	self.AUCTIONFrame.itemIcon:SetNormalTexture(itemTexture)
	self.AUCTIONFrame.itemName:SetText(itemLink)
	self.AUCTIONFrame.itemName2:SetText(((itemEquipLoc and self.itemEquipLoc[itemEquipLoc]) and (self.itemEquipLoc[itemEquipLoc].." ") or (itemType and (itemType.." ") or ""))..(itemSubType and ("["..itemSubType.."]") or (itemType or "")))
		
	self.AUCTIONFrame.BidBreak:Disable()
	
	self:SetAuctionStats()	
	self:SetAuctionColors()
		
	self:SetButtonEnable()
	
	if auctionMITBIETEN then
		self:StartStatusBar()
		self:ShowAUCTIONFrame()
		
		self:GIAFuBarChangeState()
		
		if db.config.playsound.auctionstart then
			PlaySound("igPlayerInvite") 
		end
		
		self:UpdateBidList()
		if db.config.debugadmin then
			self:Print("|cff5555ffDEBUG:|r TIMER - Handle:".. (self.ScheduleTimers.StopAuction or "nil")..", BidTime:"..db.config.bidTime)
		end
	end
		
	self:CancelTimer(self.ScheduleTimers.StopAuction, true)
	self.ScheduleTimers.StopAuction = self:ScheduleTimer("StopAuction", db.config.bidTime)
end

function GigaItemAuction:NewBidAuction(value, author)
	
	local bidPoint, itemID, bidArt, bidU80, bidPlayer, bidTime, sendTime = strsplit("#", value)
	local dbn = db.nowAuction
	local dbc = db.config
	
	if tonumber(sendTime) < dbn.last.BidTime then return end
	
	if dbc.bidTime ~= tonumber(bidTime) then
		dbc.bidTime = tonumber(bidTime)
	end
	
	if author == PLAYERNAME then auctionMITBIETEN = true end
	
--~ 	aktionsende stoppen und neu setzen
	self:CancelTimer(self.ScheduleTimers.StopAuction, true)
	self.ScheduleTimers.StopAuction = self:ScheduleTimer("StopAuction", dbc.bidTime)
	
	if auctionMITBIETEN then	
		self:AbfrageObJetztAktion(author)		
		
	--~ 	gebotbuttons kurz deaktivieren
		self:SetButtonDisable()	
		self:CancelTimer(self.ScheduleTimers.SetButtonEnable, true)
		self.ScheduleTimers.SetButtonEnable = self:ScheduleTimer("SetButtonEnable", 1)
	end
	
--~ 	aktuellen gebot eintragen
	dbn.last.BidPoint = tonumber(bidPoint)
	dbn.last.BidName = bidPlayer
	dbn.last.BidTime = tonumber(sendTime)
	dbn.last.BidArt = bidArt
	dbn.last.BidU80 = (tonumber(bidU80)==1) and true or false
--~ 	verlauf eintragen
	table_insert(dbn.cache, {BidMethod = "G", BidName = bidPlayer, BidPoint = tonumber(bidPoint), BidTime = tonumber(sendTime), BidArt = bidArt, BidU80 = (tonumber(bidU80)==1) and true or false})

	
	if auctionMITBIETEN and db.config.playsound.newgebot and author ~= PLAYERNAME and self.AUCTIONFrame:IsVisible() then
		PlaySound("AuctionWindowOpen")
	end
	
	self:SetAuctionStats()
	self:SetAuctionColors()
	
	if auctionMITBIETEN then
		if dbn.last.BidName == PLAYERNAME then
			selfBid = true
			self:ShowAUCTIONFrame()
		end
		
		self:StopStatusbar()
		if self.AUCTIONFrame:IsVisible() then
			self:StartStatusBar()
		end
		
		if dbn.last.BidName == PLAYERNAME then
			self.AUCTIONFrame.BidBreak:Enable()
			if not db.config.debugadmin then
				self:CancelTimer(self.ScheduleTimers.SetButtonEnable, true)
			end
			self:SetButtonDisable()
		else
			self.AUCTIONFrame.BidBreak:Disable()
		end
		
		
		if db.config.debugadmin or not selfBid then
			self:UpdateBidList()
		end
	end
end

function GigaItemAuction:FalseBidAuction(errorName, author)
	self:Print(L[errorName]:format(author))
	if db.config.playsound.errormsg then
		PlaySound("igQuestFailed")
	end
end

function GigaItemAuction:AbfrageObJetztAktion(author)
	if not auctionSTART and not auctionSONDERBID then
		if not StaticPopupDialogs["NewBid"] and not auctionSONDERBID then
			StaticPopupDialogs["NewBid"] = {
				text = "",
				button1 = "Ja",
				button2 = "Nein",
				timeout = 0,
				whileDead = 1,
				hideOnEscape = 1,
				OnAccept = function()  
					auctionSONDERBID = true
				end,
				OnCancel = function()
					auctionSONDERBID = false
				end,
				OnHide = function()
					auctionSONDERBID = false
				end,
			}
		end
		
		self:SendAddonMSG(self.amsg.key.getauctiondata, 1, "WHISPER", author)
		
		if not auctionSONDERBID then			
			StaticPopupDialogs["NewBid"].text = "Es wird gerade ein Item versteigert.\nDoch Sie haben keine Daten dazu.\nWollen Sie auch mit bieten und die Daten von Admin einholen?"
			StaticPopup_Show("NewBid") 
		end
	end
end
---------------------------------------
--~ INCOMING to Auctioner
---------------------------------------
function GigaItemAuction:IncomingNewBid(value, author)
	local bidPoint, itemID, bidArt, bidU80 = strsplit("#", value)
	local dbn = db.nowAuction
	local dbc = db.config
	
	local sendAttbibut = nil
	
	
	bidPoint 	= tonumber(bidPoint)
	itemID 		= tonumber(itemID)
	bidU80 		= tonumber(bidU80)
	
	if db.config.debugadmin then
		self:Print("INCOMING - BID: "..author.."#"..bidPoint.."#"..itemID.."#"..bidArt.."#"..(bidU80 and 1 or 0))
	end
	
	local priorityArt, pointArt
	local playerBidU80, auctionBidU80 = self.BidPriority[bidArt..((tonumber(bidU80)==1) and "U" or "")], self.BidPriority[dbn.last.BidArt..(dbn.last.BidU80 and "U" or "")]
	local playerBidPoint, auctionBidPoint = tonumber(bidPoint), tonumber(dbn.last.BidPoint)
	local stufenArt = {
		["hoeher"] = 3,
		["gleich"] = 2,
		["kleiner"] = 1,
	}
	
	if playerBidU80 < auctionBidU80 then
		priorityArt = stufenArt["hoeher"]
	elseif playerBidU80 == auctionBidU80 then
		priorityArt = stufenArt["gleich"]
	elseif playerBidU80 > auctionBidU80 then
		priorityArt = stufenArt["kleiner"]
	end
	
	if playerBidPoint > auctionBidPoint then
		pointArt = stufenArt["hoeher"]
	elseif playerBidPoint == auctionBidPoint then
		pointArt = stufenArt["gleich"]
	elseif playerBidPoint < auctionBidPoint then
		pointArt = stufenArt["kleiner"]
	end
	
	if 
		auctionSTART 
		and PLAYERNAME == dbn.auctionAuthor
--~ 		and tonumber(bidPoint) > tonumber(dbn.last.BidPoint) 
--~ 		and self.BidPriority[bidArt..((tonumber(bidU80)==1) and "U" or "")] <= self.BidPriority[dbn.last.BidArt..(dbn.last.BidU80 and "U" or "")]
		and (
				(priorityArt == stufenArt["gleich"] and pointArt == stufenArt["hoeher"])
				or priorityArt == stufenArt["hoeher"]
			)
		and (author ~= dbn.last.BidName or db.config.debugadmin) 
		and tonumber(itemID) == dbn.itemID 
	then
	
		sendAttbibut = bidPoint.."#"..itemID.."#"..bidArt.."#"..((tonumber(bidU80)==1) and 1 or 0).."#"..author.."#"..dbc.bidTime.."#"..getGameTimeAsUnix()
		self:SendAddonMSG(self.amsg.key.sendtruebid, sendAttbibut)
		
	elseif priorityArt == stufenArt["gleich"] and pointArt < stufenArt["hoeher"] then
		
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error2", "WHISPER", author)
		
	elseif priorityArt < stufenArt["gleich"] then
	
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error1", "WHISPER", author)
		
	elseif author == dbn.last.BidName then
		
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error3", "WHISPER", author)
		
	elseif PLAYERNAME ~= dbn.auctionAuthor then
		
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error4", "WHISPER", author)
		
	elseif tonumber(itemID) ~= dbn.itemID then
		
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error6", "WHISPER", author)
	
	elseif not auctionSTART then
	
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error7", "WHISPER", author)	
		
	end
end

function GigaItemAuction:IncomingPassLastBid(author)
	local dbn = db.nowAuction
	local dbc = db.config
	
	local cache = dbn.cache
	local sendAttbibut = nil
	local foundLast = false
	local editLast = false
	
	if author == dbn.last.BidName then
--~ 		letzen bieter ermitteln
		table_sort(cache,	function(w1,w2)
								if w1["BidTime"] > w2["BidTime"] then
									return true
								end
							end)
--~ 		pass in cache eintragen
--~ 		cache[1].BidMethod = "P"
		
		for i, p in pairs(cache) do
			if p.BidMethod == "G" then
				if editLast then
--~ 					letzen bieter senden
					table_remove(cache,i)
					sendAttbibut = p.BidPoint.."#"..dbn.itemID.."#"..p.BidArt.."#"..((tonumber(p.BidU80)==1) and 1 or 0).."#"..p.BidName.."#"..dbc.bidTime.."#"..getGameTimeAsUnix()
					self:SendAddonMSG(self.amsg.key.sendtruebid, sendAttbibut)
					self:SendAddonMSG(self.amsg.key.sendfalsebid, "hinweis1")
					foundLast = true
					break
				else
					cache[i].BidMethod = "P"
					editLast = true
				end
			end
		end
		
		if not foundLast then
			self:SendAdminResetAuction()
			selfBid = false
		end
	else
		self:SendAddonMSG(self.amsg.key.sendfalsebid, "error5", "WHISPER", author)
	end
end

function GigaItemAuction:IncomingAuctionDATA(value, author)
	local dbn = db.nowAuction
	local dbc = db.config
	local itemID, auctionAuthor, channel, BidName, BidPoint, BidTime, BidArt, BidU80 = strsplit("#", value)
	
--~ 	Itemdata defenieren
	local itemName, itemLink, itemRarity, _, _, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(tonumber(itemID))
	
	auctionMITBIETEN = self:ItemFilterCheck(itemType, itemSubType, itemEquipLoc)
	
	if author == PLAYERNAME then
		auctionMITBIETEN = true
	end
	
	dbn.itemID = tonumber(itemID)
	dbn.itemLink = itemLink
	dbn.auctionAuthor = author
	dbn.channel = channel
	dbn.last.BidName = BidName
	dbn.last.BidPoint = tonumber(BidPoint)
	dbn.last.BidArt = BidArt
	dbn.last.BidTime = tonumber(BidTime)
	dbn.last.BidU80 = ((tonumber(BidU80)==1) and true or false)
	
	self:SendAddonMSG(self.amsg.key.getbidtime, 1, "WHISPER", author)
	self:StopStatusbar()
	
	self.AUCTIONFrame.itemIcon:SetNormalTexture(itemTexture)
	self.AUCTIONFrame.itemName:SetText(itemLink)
	self.AUCTIONFrame.itemName2:SetText((itemEquipLoc and self.itemEquipLoc[itemEquipLoc] and (self.itemEquipLoc[itemEquipLoc].." ") or "")..(itemSubType and ("["..itemSubType.."]") or (itemType or "")))
		
	self.AUCTIONFrame.BidBreak:Disable()
	
	self:SetAuctionStats()	
	self:SetAuctionColors()
	
	if auctionSONDERBID and auctionMITBIETEN then
		self:StartAdmin()	
		self:ShowAUCTIONFrame()
	else
		self:HideAUCTIONFrame()
	end
	
	auctionSONDERBID = false	
	auctionSTART = true
	
	if self.AUCTIONFrame:IsVisible() and auctionMITBIETEN then
		self:StartStatusBar()
	end
	
	self:GIAFuBarChangeState()
	
	self:SetButtonEnable()
	
	if db.config.playsound.auctionstart and auctionMITBIETEN then
		PlaySound("igPlayerInvite") 
	end
	
	self:UpdateBidList()
	
	self:CancelTimer(self.ScheduleTimers.StopAuction, true)
	self.ScheduleTimers.StopAuction = self:ScheduleTimer("StopAuction", db.config.bidTime)
end

function GigaItemAuction:ResetAuction(author)
--~ 	Ãœberpruefung, ob der Sender die Berechtigung hat eine Action zu starten
	if not self:CheckPriority(author) then 
		if PLAYERNAME == author then
			self:Print(L["secutity4"])
		end
		return 
	end
	
    for k in pairs(db.nowAuction.cache) do
        db.nowAuction.cache[k] = nil
    end
	local dbn = db.nowAuction
	
	dbn.last.BidName = ""
	dbn.last.BidPoint = tonumber(0)
	dbn.last.BidArt = "X"
	dbn.last.BidU80 = false

	self:StopStatusbar()
	
	self.AUCTIONFrame.BidBreak:Disable()
	
	self:SetAuctionStats()	
	self:SetAuctionColors()
	
	if auctionMITBIETEN then
		self:StartStatusBar()
		self:ShowAUCTIONFrame()
	end
	
	self:SetButtonEnable()
	
	self:UpdateBidList()
		
	self.ADMINFrame.pauseButton:Enable()
	self.ADMINFrame.aLongButton:Enable()
	self.ADMINFrame.startButton:Disable()
	
	self:SetStatusbarText(L["statusbar_text_start"])
	
	self:CancelTimer(self.ScheduleTimers.StopAuction, true)
	self.ScheduleTimers.StopAuction = self:ScheduleTimer("StopAuction", db.config.bidTime)
end


---------------------------------------
--~ Auction steuerung
---------------------------------------
function GigaItemAuction:PauseStartAuction(author,start)
--~ 	ÃœberprÃ¼fung, ob der Sender die Berechtigung hat eine Action zu starten
	if not self:CheckPriority(author) then 
		if PLAYERNAME == author then
			self:Print(L["secutity5"])
		end
		return 
	end
	local dbn = db.nowAuction
	
	if start then
		auctionPAUSE = false
		self:StopStatusbar()
		
		if auctionMITBIETEN then
			self:AbfrageObJetztAktion(author)
			
			if self.AUCTIONFrame:IsVisible() then
				self:StartStatusBar()
				self:SetStatusbarText(L["statusbar_text_start"])
				
				if db.config.playsound.pausestart then
					PlaySound("AuctionWindowOpen")
				end
			end
		end
		
		self:CancelTimer(self.ScheduleTimers.StopAuction, true)
		self.ScheduleTimers.StopAuction = self:ScheduleTimer("StopAuction", db.config.bidTime)
		
		if dbn.last.BidName == PLAYERNAME then
			self.AUCTIONFrame.BidBreak:Enable()
			self:SetButtonDisable()
		else
			self.AUCTIONFrame.BidBreak:Disable()
			self:SetButtonEnable()
		end
		
		self.ADMINFrame.pauseButton:Enable()
		self.ADMINFrame.aLongButton:Enable()
		self.ADMINFrame.startButton:Disable()
		
	else
		auctionPAUSE = true
		self:CancelTimer(self.ScheduleTimers.StopAuction, true)
		self:PauseStatusbar()
		self.AUCTIONFrame.BidBreak:Disable()
		self:SetButtonDisable()
		
		self.ADMINFrame.pauseButton:Disable()
		self.ADMINFrame.aLongButton:Disable()
		self.ADMINFrame.startButton:Enable()
		
		if db.config.showAuctionWindow then
			self:SetStatusbarText(L["statusbar_text_pause"])
			
			if db.config.playsound.pause and auctionMITBIETEN then
				PlaySound("igQuestFailed") 
			end
		end
		
	end		
end

function GigaItemAuction:StopAuction()
	local dbn = db.nowAuction
	
	self:CancelTimer(self.ScheduleTimers.StopAuction, true)
	self:StopStatusbar()
	self:HideAUCTIONFrame()
	
	auctionSTART = false
	auctionSONDERBID = false
	auctionPAUSE = false
	auctionMITBIETEN = false
	
	if adminBreak then
		self:Print(L["auctionBreak"]:format(adminBreak))	
		if db.config.playsound.errormsg then
			PlaySound("igQuestFailed") 
		end
	elseif dbn.last.BidName ~= "" and tonumber(dbn.last.BidPoint) > 0 then
		local nowBidPoint = dbn.last.BidPoint
		local nowBidArt = " |cff555555("..self.BidArt.kula[dbn.last.BidArt]..(dbn.last.BidU80 and (" |cffff5555"..self.BidArt.lang[4].."|r|cff555555") or "")..")|r"
		
		local _, class = self:GetGuildPlayer(dbn.last.BidName)
		local ccolor = self:GetClassHexColor(class)
--~             item post
		self:Print(L["auctionTrue"]:format(ccolor, dbn.last.BidName, dbn.itemLink, nowBidPoint, nowBidArt))
		
		
		
		if db.config.playsound.auctionend then
			PlaySound("igQuestListComplete") 
		end
		
		while #db.auctionCache > 9 do
			table_remove(db.auctionCache, #db.auctionCache)
		end
		
		table_insert(db.auctionCache, 
			{
				BidName = dbn.last.BidName,
				BidItem = dbn.itemLink,
				BidPoint = dbn.last.BidPoint, 
				BidTime = getGameTimeAsUnix(), 
				BidArt = dbn.last.BidArt, 
				BidU80 = dbn.last.BidU80,
				BidAchiev = true
			}
		)
	else
		self:Print(L["auctionNoBid"]:format(dbn.itemLink))
		if db.config.playsound.auctionend then
			PlaySound("igQuestFailed") 
		end
		
		while #db.auctionCache > 9 do
			table_remove(db.auctionCache, #db.auctionCache)
		end
		
		table_insert(db.auctionCache, 
			{
				BidName = L["nobody"],
				BidItem = dbn.itemLink,
				BidPoint = 0, 
				BidTime = getGameTimeAsUnix(), 
				BidArt = "M", 
				BidU80 = false,
				BidAchiev = false
			}
		)
	end
		
	adminBreak = false
	selfBid = false

	self:StopAdmin()
	
	self:ClearNowAuction()
	
	self:GIAFuBarChangeState()
end

---------------------------------------
-- SendAuction
---------------------------------------
function GigaItemAuction:SendBidpoint(bidPoint)
	local dbn = db.nowAuction
	local dbc = db.config
	
	local sendAttbibut = nil
	
	if dbn.itemID and dbn.itemID ~= "" and tonumber(dbn.itemID) > 0 and dbn.auctionAuthor ~= "" then
		self:Print(L["BID"].." - |cff72ff00"..bidPoint.."|r DKP [|cff72ff00".. self.BidArt.kula[dbc.bidArt]..(dbc.bidU80 and ("|r |cffff5555(u"..db.config.bidUP..")") or "").."|r]")
		
		if db.config.debugadmin then
			self:Print("SEND - BID: "..bidPoint.."#"..dbn.itemID.."#"..dbc.bidArt.."#"..(dbc.bidU80 and 1 or 0))
		end
		
		sendAttbibut = bidPoint.."#"..dbn.itemID.."#"..dbc.bidArt.."#"..(dbc.bidU80 and 1 or 0)
		self:SendAddonMSG(self.amsg.key.bidpoint, sendAttbibut, "WHISPER", dbn.auctionAuthor)
	else
		self:Print(L["hinweis3"])
	end

	self:CancelTimer(self.ScheduleTimers.SetButtonEnable, true)
	self.ScheduleTimers.SetButtonEnable = self:ScheduleTimer("SetButtonEnable", 1)
end

function GigaItemAuction:SendPassLastBid()
	local dbn = db.nowAuction
	if dbn.itemID and dbn.itemID ~= "" and tonumber(dbn.itemID) > 0 and dbn.auctionAuthor ~= "" then
		self:SendAddonMSG(self.amsg.key.sendpassbid, 1, "WHISPER", dbn.auctionAuthor)
	else
		self:Print(L["hinweis3"])
	end
end

---------------------------------------
-- ClearNowAuction Database
---------------------------------------
function GigaItemAuction:ClearNowAuction()	
    for k in pairs(db.nowAuction.cache) do
        db.nowAuction.cache[k] = nil
    end
	
	db.nowAuction.last = nil
	db.nowAuction = nil
	db.nowAuction = {}
	db.nowAuction.last = {}
	db.nowAuction = {
		itemID = 0,
		itemLink = "",
		auctionAuthor = "",
		channel = "",
		last = {
			BidName = "",
			BidPoint = 0,
			BidTime = 0,
			BidArt = "X",
			BidU80 = false
		},
		cache = nil,
	}
	db.nowAuction.cache = {}
end
---------------------------------------
-- Auction Stats/Colors/Buttons
---------------------------------------
function GigaItemAuction:SetAuctionStats()
	local dbn = db.nowAuction
	local dbc = db.config
	
	local nowBidPoint = dbn.last.BidPoint or 0
	local nowBidArt = nowBidPoint > 0 and (" |cff888888("..dbn.last.BidArt..(dbn.last.BidU80 and (" |cffff1111"..self.BidArt.kurz[4].."|r|cff888888") or "")..")|r") or ""
	self.AUCTIONFrame.AktuellerPreis:SetText(nowBidPoint..nowBidArt)
	
	self:SetAuctionBidStats()
	
	if dbn.last.BidName ~= "" then
		if dbn.last.BidName == PLAYERNAME or (dbn.auctionAuthor == PLAYERNAME and not selfBid) then
			self.AUCTIONFrame.Bieter:SetText(dbn.last.BidName)
		else
			self.AUCTIONFrame.Bieter:SetText(L["anonym"])
		end
	else
		self.AUCTIONFrame.Bieter:SetText(L["nobody"])
	end
end

function GigaItemAuction:SetAuctionBidStats()
	local dbn = db.nowAuction
	local dbc = db.config
	
	local bidStep1, bidStep2, bidStep3, bidStep4 = dbc.bidStep.step1, dbc.bidStep.step2, dbc.bidStep.step3, dbc.bidStep.step4
	local nowBidPoint = (dbn.last.BidPoint or 0)
	local priorityArt, pointArt
	local playerBidU80 	= self.BidPriority[dbc.bidArt..(dbc.bidU80 and "U" or "")]
	local auctionBidU80 = self.BidPriority[dbn.last.BidArt..(dbn.last.BidU80 and "U" or "")]
	local stufenArt = {
		["hoeher"] = 3,
		["gleich"] = 2,
		["kleiner"] = 1,
	}
	
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r SET - SetAuctionBidStats() - playerBidU80:  " .. (playerBidU80 and playerBidU80 or "nil")..", auctionBidU80:  " .. (auctionBidU80 and auctionBidU80 or "nil"))
	end
	
	if playerBidU80 < auctionBidU80 then
		priorityArt = stufenArt["hoeher"]
	elseif playerBidU80 == auctionBidU80 then
		priorityArt = stufenArt["gleich"]
	elseif playerBidU80 > auctionBidU80 then
		priorityArt = stufenArt["kleiner"]
	end
	
	if not auctionPAUSE then
		if priorityArt >= stufenArt["gleich"] then
			self:SetButtonEnable()
		elseif priorityArt == stufenArt["kleiner"] then
			self:SetButtonDisable()
		end
	else
		self:SetButtonDisable()
	end
	
	if priorityArt == stufenArt["hoeher"] then
		bidStep1 = dbc.bidStep.step1
		bidStep2 = dbc.bidStep.step2
		bidStep3 = dbc.bidStep.step3
		bidStep4 = dbc.bidStep.step4
	elseif priorityArt <= stufenArt["gleich"] then
		bidStep1 = dbc.bidStep.step1 + nowBidPoint
		bidStep2 = dbc.bidStep.step2 + nowBidPoint
		bidStep3 = dbc.bidStep.step3 + nowBidPoint
		bidStep4 = dbc.bidStep.step4 + nowBidPoint
	end
		
	
	self.AUCTIONFrame.Bid1:SetText(bidStep1)
	self.AUCTIONFrame.Bid2:SetText(bidStep2)
	self.AUCTIONFrame.Bid3:SetText(bidStep3)
	self.AUCTIONFrame.Bid4:SetText(bidStep4)

end

function GigaItemAuction:SetAuctionColors()
	local dbn = db.nowAuction
	
	if dbn.last.BidName ~= "" then
		if dbn.last.BidName == PLAYERNAME then
			self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.green))	
			self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.green))
		elseif not selfBid then
			self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.yellow))	
			self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.yellow))
		else
			self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.red))	
			self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.red))		
		end
	else
		self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.neutral))	
		self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.neutral))
	end
end

function GigaItemAuction:SetButtonDisable()
	self.AUCTIONFrame.Bid1:Disable()
	self.AUCTIONFrame.Bid2:Disable()
	self.AUCTIONFrame.Bid3:Disable()
	self.AUCTIONFrame.Bid4:Disable()
end
function GigaItemAuction:SetButtonEnable()
	self.AUCTIONFrame.Bid1:Enable()
	self.AUCTIONFrame.Bid2:Enable()
	self.AUCTIONFrame.Bid3:Enable()
	self.AUCTIONFrame.Bid4:Enable()
end





---------------------------------------
--~ SendMessages
---------------------------------------
function GigaItemAuction:SendAddonMSG(value, msg, channel, player)
	local dbn = db.nowAuction
    local channel = channel or dbn.channel
	local player = player or dbn.auctionAuthor or nil
    SendAddonMessage(self.amsg.prefix, value.." "..msg, channel, channel == "WHISPER" and player or nil)
end

function GigaItemAuction:Whisper(player, text, noprefix)
    local PreText = noprefix and "" or "GIA: "
    local msg = ""
    if player and text then
        msg = PreText..text
        sentWhispers[msg] = true
        SendChatMessage(msg, "WHISPER", GetLanguageByIndex(0), player)
    end
end







function GigaItemAuction:GetGuildPlayer(player)
    if IsInGuild() and player then
        local numGuildMembers = GetNumGuildMembers(true)
        for i = 1, numGuildMembers, 1 do
            name, rank, _, _, _, _, _, _, _, _, classconst = GetGuildRosterInfo(i)
            if name and string.lower(name) == string.lower(player) then
                return name, classconst, rank
            end
        end        
    end
    return L["unknown"], L["unknown"], L["unknown"]
end


---------------------------------------
--~ VERSIONS CHECK
---------------------------------------
function GigaItemAuction:VersionChecks()
	local channel, msg = nil, nil
	if UnitInRaid("player") then
		channel = "RAID"
		msg = L["VersionCheckTextRaid"]
	elseif IsInGuild() then
		channel = "GUILD"
		msg = L["VersionCheckTextGuild"]
	else
		return
	end
    self:SendAddonMSG(self.amsg.key.sendversioncheck, self.revision, channel)
	self:CancelTimer(self.ScheduleTimers.VersionCheckEnd, true)
	self.ScheduleTimers.VersionCheckEnd = self:ScheduleTimer("VersionCheckEnd", 10)
    self:Print(msg.."...")
end

function GigaItemAuction:VersionShowAll(value)
    local ver, class, player, admin, bidTime, color, color2
	ver, class, player, admin, bidTime = strsplit("#", value)
	ver 			= tonumber(ver)
	bidTime 		= tonumber(bidTime)
	self.revision 	= tonumber(self.revision)
	
	if ver < self.revision then
		color = "|cffff6e6e"
	elseif ver > self.revision then
		color = "|cff72ff00"
	else
		color = "|cffffffff"
	end
	
	if bidTime == db.config.bidTime then
		color2 = "|cffffffff"
	else
		color2 = "|cffff6e6e"
	end
	
	if not waitForVersionIncomig then		
		for k in pairs(versionList) do
			versionList[k] = nil
		end
		versionList = nil
		versionList = {}
		waitForVersionIncomig = true
	end
	
	if not versionList[ver] then
		versionList[ver] = {}
	end
	table_insert(versionList[ver], {
					["player"] = player,
					["class"] = class,
					["admin"] = admin,
					["bidTime"] = bidTime
	})
	
	self:Print("|cff"..self:GetClassHexColor(class)..""..player.."|r: r"..color..ver.."|r"..(tonumber(admin) == 1 and " |cff55ff55(Admin)|r" or "").."  ["..color2..bidTime.."|rsec.]")
end

function GigaItemAuction:VersionCheckEnd()
	local oldvermsg, newvermsg, gleichvermsg = {}, {}, {}
	local playersList = ''

	for ver, players in pairs(versionList) do
		if ver < self.revision then
			table_insert(oldvermsg, #players)
			playersList = playersList .. ' | |cffff5555Version: r'..ver..'|r '
			for i, v in pairs(players) do
				playersList = playersList .. "|cff"..self:GetClassHexColor(v.class)..""..v.player.."|r, "
			end			
		elseif ver > self.revision then
			table_insert(newvermsg, #players)
		else
			table_insert(gleichvermsg, #players)			
		end
	end
		
	local online, channel
	local playersOnline = 0
	
	if UnitInRaid("player") then
		local raidNum = GetNumRaidMembers()
		if raidNum > 0 then
			for i=1, raidNum do 
				_, _, _, _, _, _, _, online = GetRaidRosterInfo(i);
				if online then
					playersOnline = playersOnline + 1
				end
			end
		end
		channel = "RAID"
	elseif IsInGuild() then
		local numGuildMembers = GetNumGuildMembers(true)
		for i = 1, numGuildMembers, 1 do
			_, _, _, _, _, _, _, _, online = GetGuildRosterInfo(i)
			if online then
				playersOnline = playersOnline + 1
			end
		end
		channel = "GILDEN"
	end
	
	local gesamtVersion = (#newvermsg>0 and newvermsg[1] or 0) + (#gleichvermsg>0 and gleichvermsg[1] or 0) + (#oldvermsg>0 and oldvermsg[1] or 0)
	if gesamtVersion > 0 then
		self:Print(L["version1"]:format(channel,gesamtVersion,playersOnline))
	end
	if #newvermsg > 0 then
		self:Print(L["version2"]:format(newvermsg[1]))
	end
	if #gleichvermsg > 0 then
		self:Print(L["version3"]:format(gleichvermsg[1]))
	end
	if #oldvermsg > 0 then
		table_insert(oldvermsg, playersList)
		self:Print(L["version4"]:format(oldvermsg[1],oldvermsg[2]))
	end
	
	waitForVersionIncomig = false
end




---------------------------------------
--~ Colors
---------------------------------------
local default_color = {
	r = 1,
	g = 0,
	b = 0,
	a = 0.6
}
function GetClassColor(class)
    if class then
        class = string.upper(class)
        if RAID_CLASS_COLORS and RAID_CLASS_COLORS[class] then
            return RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
        end
    end
	return default_color.r, default_color.g, default_color.b
end

function GigaItemAuction:GetClassHexColor(class)
	local r, g, b = GetClassColor(class)
	return string.format("%02x%02x%02x", r * 255, g * 255, b * 255)
end

---------------------------------------
-- FUBAR OPTIONS
---------------------------------------
function GigaItemAuction:GIAFuBarOnInitialize()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	
	if LDB and not IsAddOnLoaded("Broker2FuBar") and not IsAddOnLoaded("FuBar") then
		GIALauncher = LDB:NewDataObject("GigaItemAuction", {
			type = "launcher",
			icon = "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncON",
			OnClick = function(clickedframe, button)
				if IsShiftKeyDown() then GigaItemAuction:ShowConfig() else GigaItemAuction:ToggleAUCTIONFrame() end
			end,
			OnTooltipShow = function(tt)
				tt:AddLine("GigaItemAuction")
				tt:AddLine(L["hint"])
			end,
		})
		if LDBIcon and not IsAddOnLoaded("Broker2FuBar") and not IsAddOnLoaded("FuBar") then
			LDBIcon:Register("GigaItemAuction", GIALauncher, db.MinimapIcon)
		end
	end

	-- Optional launcher support for LFBP-3.0 if present, this code is placed here so
	-- that it runs after all other addons have loaded since we don't embed LFBP-3.0
	-- Yes, this is one big hack since LFBP-3.0 is a Rock library, and we embed it
	-- via Ace3. OnEmbedInitialize() needs to be called manually.
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) and not IsAddOnLoaded("FuBar2Broker") and IsAddOnLoaded("FuBar") then
		local LFBP = LibStub:GetLibrary("LibFuBarPlugin-3.0")
		LibStub("AceAddon-3.0"):EmbedLibrary(self, "LibFuBarPlugin-3.0")
		self:SetFuBarOption("tooltipType", "Tablet-2.0")
		self:SetFuBarOption("hasNoColor", true)
		self:SetFuBarOption("cannotDetachTooltip", true)
		self:SetFuBarOption("hideWithoutStandby", true)
		self:SetFuBarOption("iconPath", [[Interface\AddOns\GigaItemAuction\Icons\SyncON]])
		self:SetFuBarOption("hasIcon", true)
		self:SetFuBarOption("defaultPosition", "LEFT")
		self:SetFuBarOption("tooltipHiddenWhenEmpty", true)
		self:SetFuBarOption("clickableTooltip", true)
		self:SetFuBarOption("configType", "None")
		LFBP:OnEmbedInitialize(self)
		function GigaItemAuction:OnUpdateFuBarTooltip()
			GigaItemAuction:GIAFuBarTooltipUpdate()
		end
		function GigaItemAuction:OnFuBarClick(button)
			if IsShiftKeyDown() then GigaItemAuction:ShowConfig() else GigaItemAuction:ToggleAUCTIONFrame() end			
		end
		function GigaItemAuction:OnFuBarUpdateText()
			self:SetFuBarText("GigaItemAuction")
		end
		self.optionsFrames.FuBar = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GigaItemAuction", L["FuBar Options"], "GigaItemAuction", "FuBar")
		self:UpdateFuBarSettings()
	end
end

function GigaItemAuction:GIAFuBarTooltipUpdate()
	local dbn = db.nowAuction
	local auctions = db.auctionCache
	local player, class
	local nowBidArt, nowBidPoint
	
	table_sort(auctions,	function(w1,w2)
								if w1["BidTime"] > w2["BidTime"] then
									return true
								end
							end)
    local category_auctionlist = {
        'columns', 4,
        'showWithoutChildren', true,
        'text', "Name",
        'child_textR', 1,
        'child_textG', 1,
        'child_textB', 1,
        'text2', "Item",
        'child_text2R', 1,
        'child_text2G', 1,
        'child_text2B', 6/16,
        'text3', "Datum",
        'child_text3R', 1,
        'child_text3G', 1,
        'child_text3B', 6/16,
        'text4', "DKP",
        'child_text4R', 1,
        'child_text4G', 1,
        'child_text4B', 1,
    }
	
--~     ------------------------------------------
--~     AuctionItem Lines
    if #auctions > 0 then
        local apl = false
        local auctioncat = tablet:AddCategory(unpack(category_auctionlist))
        for i, v in pairs(auctions) do
            tmp = {}
			if v.BidName ~= L['nobody'] then
				_, class = self:GetGuildPlayer(v.BidName)
			else
				class = L['unknown']
			end
--~             name
            table_insert(tmp, 'text')
            table_insert(tmp, "|cff"..self:GetClassHexColor(class)..v.BidName.."|r")
			
--~             item
            table_insert(tmp, 'text2')
            table_insert(tmp, v.BidItem)
			
--~             datum
            table_insert(tmp, 'text3')
            table_insert(tmp, getCurrentMiniDate(v.BidTime))
			
--~             DKP
			if v.BidAchiev then
				nowBidPoint = v.BidPoint
				nowBidArt = " |cff888888("..self.BidArt.kula[v.BidArt]
				nowBidArt = nowBidArt .. (v.BidU80 and (" |cffff5555"..self.BidArt.lang[4].."|r|cff888888") or "")..")|r"
			else
				nowBidPoint = "-"
				nowBidArt = ""
			end
            table_insert(tmp, 'text4')
            table_insert(tmp, (nowBidPoint..nowBidArt))
			
--~             funktion
            table_insert(tmp, 'func')
            table_insert(tmp, 'GIAFuBarOnItemClick')
            table_insert(tmp, 'arg1')
            table_insert(tmp, self)
            table_insert(tmp, 'arg2')
            table_insert(tmp, i)
			
--~             hacken
            if v.BidName == PLAYERNAME then
                apl = true
            else
                apl = false
            end
            table_insert(tmp,'hasCheck')
            table_insert(tmp, true)
            table_insert(tmp,'checked')
            table_insert(tmp, apl)
	
			auctioncat:AddLine("arg1", i, unpack(tmp))
		end
	end
	local category_optionen = {
        'columns', 1,
        'showWithoutChildren', true,
        'text', "Optionen",
        'child_textR', 1,
        'child_textG', 1,
        'child_textB', 1,
    }
	local cat = tablet:AddCategory(unpack(category_optionen))
	cat:AddLine()
	cat:AddLine('text', L["VersionCheckText"], 'func', function() GigaItemAuction:VersionChecks() end, 				'textR', 1, 'textG', 1, 'textB', 0)
	cat:AddLine('text', L["Open the configuration dialog"], 'func', function() GigaItemAuction:ShowConfig() end, 	'textR', 1, 'textG', 1, 'textB', 0)
	cat:AddLine('text', L["Toggle GIA"], 'func', function() GigaItemAuction:ToggleAUCTIONFrame() end, 				'textR', 1, 'textG', 1, 'textB', 0)
	if self:CheckPriority(PLAYERNAME) then
		cat:AddLine('text', L["Admin GIA"], 'func', function() GigaItemAuction:ShowADMINFrame() end, 				'textR', 1, 'textG', 1, 'textB', 0)
	end
    tablet:SetHint(self.hint)
end

function GigaItemAuction:GIAFuBarOnItemClick(itemId)
    if not itemId then return end
    if IsShiftKeyDown() then
        table_remove(GigaItemAuction.db.profile.auctionCache, itemId)
    end
end

function GigaItemAuction:GIAFuBarChangeState()
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) and IsAddOnLoaded("FuBar") then 
		local LFBP = LibStub:GetLibrary("LibFuBarPlugin-3.0")
		LibStub("AceAddon-3.0"):EmbedLibrary(self, "LibFuBarPlugin-3.0")
		if self:IsEnabled() then
			if db.nowAuction.itemLink ~= "" then
				self:SetFuBarOption("iconPath", "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncON2")
				self.hint = L["hint"]
			else
				self:SetFuBarOption("iconPath", "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncON")
				self.hint = L["hint"]
			end
		else
			self:SetFuBarOption("iconPath", "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncOFF")
			self.hint = L["disabledhint"]
		end
		LFBP:OnEmbedInitialize(self)
		self:UpdateFuBarSettings()
	end
end

function GigaItemAuction:UpdateFuBarSettings()
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) then
		if db.FuBar.HideMinimapButton then
			self:Hide()
		else
			self:Show()
			if self:IsFuBarMinimapAttached() ~= db.FuBar.AttachMinimap then
				self:ToggleFuBarMinimapAttached()
			end
		end
	end
end

---------------------------------------
-- OPTIONEN
---------------------------------------

local function GetFuBarMinimapAttachedStatus(info)
	return GigaItemAuction:IsFuBarMinimapAttached() or db.FuBar.HideMinimapButton
end



function GigaItemAuction:SetupOptions()
	self.optionsFrames 	= {}
	self.OptionsConfig 	= self:GetOptionsConfig()
	self.OptionsSlash 	= self:GetOptionsSlash()

	-- setup options table
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("GigaItemAuction", self.OptionsConfig)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("GIASlashCommand", self.OptionsSlash, L["Slash-Commands1"])
	LibStub("AceConfig-3.0"):RegisterOptionsTable("GIASlashCommand", self.OptionsSlash, L["Slash-Commands2"])
	local ACD3 = LibStub("AceConfigDialog-3.0")

	-- The ordering here matters, it determines the order in the Blizzard Interface Options
	self.optionsFrames.GigaItemAuction = ACD3:AddToBlizOptions("GigaItemAuction", nil, nil, "General")
	self.optionsFrames.ItemFilter = ACD3:AddToBlizOptions("GigaItemAuction", L["Filter Settings"], "GigaItemAuction", "ItemFilter")
	
	
	self:RegisterModuleOptions("GIASlashCommand", self.OptionsSlash, L["Slash Command"])
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), L["Profiles"])

	-- Add ordering data to the option table generated by AceDBOptions-3.0
	self.OptionsConfig.args.Profiles.order = -2
end

function GigaItemAuction:RegisterModuleOptions(name, optionTbl, displayName)
	self.OptionsConfig.args[name] = (type(optionTbl) == "function") and optionTbl() or optionTbl
	self.optionsFrames[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GigaItemAuction", displayName, "GigaItemAuction", name)
end

function GigaItemAuction:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrames.Profiles)
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrames.GigaItemAuction)
end